## hackrf 2024.02.1

=== Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library.  If not, see <http://www.gnu.org/licenses/>.
##

PREFIX		?= arm-none-eabi
#PREFIX		?= arm-elf

STYLECHECK      := scripts/checkpatch.pl
STYLECHECKFLAGS := --no-tree -f --terse --mailback

ifeq ($(DETECT_TOOLCHAIN),)
DESTDIR		?= /usr/local
else
DESTDIR		?= $(shell dirname $(shell readlink -f $(shell which $(PREFIX)-gcc)))/..
endif

INCDIR		:= $(DESTDIR)/$(PREFIX)/include
LIBDIR		:= $(DESTDIR)/$(PREFIX)/lib
SHAREDIR	:= $(DESTDIR)/$(PREFIX)/share/libopencm3/scripts
INSTALL		:= install

SRCLIBDIR:= $(realpath lib)

TARGETS:= stm32/f0 stm32/f1 stm32/f2 stm32/f3 stm32/f4 stm32/l1 lpc13xx lpc17xx \
	  lpc43xx/m4 lpc43xx/m0 lm3s lm4f \
	  efm32/efm32tg efm32/efm32g efm32/efm32lg efm32/efm32gg sam/3x sam/3n

# Be silent per default, but 'make V=1' will show all compiler calls.
ifneq ($(V),1)
Q := @
# Do not print "Entering directory ...".
MAKEFLAGS += --no-print-directory
endif

YAMLFILES	:= $(shell find . -name 'irq.yaml')
STYLECHECKFILES := $(shell find . -name '*.[ch]')

all: build

build: lib

%.genhdr:
	@printf "  GENHDR  $*\n";
	@./scripts/irq2nvic_h ./$*;

%.cleanhdr:
	@printf "  CLNHDR  $*\n";
	@./scripts/irq2nvic_h --remove ./$*

LIB_DIRS:=$(wildcard $(addprefix lib/,$(TARGETS)))
$(LIB_DIRS): $(YAMLFILES:=.genhdr)
	@printf "  BUILD   $@\n";
	$(Q)$(MAKE) --directory=$@ SRCLIBDIR=$(SRCLIBDIR)

lib: $(LIB_DIRS)
	$(Q)true

install: lib
	@printf "  INSTALL headers\n"
	$(Q)$(INSTALL) -d $(INCDIR)/libopencm3
	$(Q)$(INSTALL) -d $(INCDIR)/libopencmsis
	$(Q)$(INSTALL) -d $(LIBDIR)
	$(Q)$(INSTALL) -d $(SHAREDIR)
	$(Q)cp -r include/libopencm3/* $(INCDIR)/libopencm3
	$(Q)cp -r include/libopencmsis/* $(INCDIR)/libopencmsis
	@printf "  INSTALL libs\n"
	$(Q)$(INSTALL) -m 0644 lib/*.a $(LIBDIR)
	@printf "  INSTALL ldscripts\n"
	$(Q)$(INSTALL) -m 0644 lib/*.ld $(LIBDIR)
	$(Q)$(INSTALL) -m 0644 lib/efm32/*/*.ld $(LIBDIR)
	@printf "  INSTALL scripts\n"
	$(Q)$(INSTALL) -m 0644 scripts/*.scr $(SHAREDIR)

doc:
	$(Q)$(MAKE) -C doc html

clean: $(YAMLFILES:=.cleanhdr) $(LIB_DIRS:=.clean) $(EXAMPLE_DIRS:=.clean) doc.clean styleclean

%.clean:
	$(Q)if [ -d $* ]; then \
		printf "  CLEAN   $*\n"; \
		$(MAKE) -C $* clean SRCLIBDIR=$(SRCLIBDIR) || exit $?; \
	fi;


stylecheck: $(STYLECHECKFILES:=.stylecheck)
styleclean: $(STYLECHECKFILES:=.styleclean)

# the cat is due to multithreaded nature - we like to have consistent chunks of text on the output
%.stylecheck:
	$(Q)if ! grep -q "* It was generated by the irq2nvic_h script." $* ; then \
		$(STYLECHECK) $(STYLECHECKFLAGS) $* > $*.stylecheck; \
		if [ -s $*.stylecheck ]; then \
			cat $*.stylecheck; \
		else \
			rm -f $*.stylecheck; \
		fi; \
	fi;

%.styleclean:
	$(Q)rm -f $*.stylecheck;

.PHONY: build lib $(LIB_DIRS) install doc clean stylecheck styleclean

=== docs/requirements.txt ===
sphinx==7.2.6
sphinx_rtd_theme==2.0.0
readthedocs-sphinx-search==0.3.2
jinja2==3.1.3

=== host/CMakeLists.txt ===
#top dir cmake project for libhackrf + tools

cmake_minimum_required(VERSION 2.8.12)
project (HackRF C)

set(CMAKE_C_FLAGS "$ENV{CFLAGS}" CACHE STRING "C Flags")

add_subdirectory(libhackrf)
add_subdirectory(hackrf-tools)

########################################################################
# Create uninstall target
########################################################################

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)


add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== firmware/blinky/CMakeLists.txt ===
# Copyright 2012 Michael Ossmann <mike@ossmann.com>
# Copyright 2012 Jared Boone <jared@sharebrained.com>
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

cmake_minimum_required(VERSION 3.1.3)
set(CMAKE_TOOLCHAIN_FILE ../toolchain-arm-cortex-m.cmake)

project(blinky C)

include(../hackrf-common.cmake)

set(SRC_M4
	blinky.c
)

DeclareTargets()

=== host/hackrf-tools/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013 Benjamin Vernoux
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

# Based heavily upon the libftdi cmake setup.

cmake_minimum_required(VERSION 2.8.12)
project(hackrf-tools C)
set(PACKAGE hackrf-tools)
include(${PROJECT_SOURCE_DIR}/../cmake/set_release.cmake)
add_definitions(-DTOOL_RELEASE="${RELEASE}")
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)

if(MSVC)
include_directories(getopt)
add_definitions(/D _CRT_SECURE_NO_WARNINGS)
else()
add_definitions(-Wall)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu90")
endif()

if(NOT libhackrf_SOURCE_DIR)
find_package(LIBHACKRF REQUIRED)
include_directories(${LIBHACKRF_INCLUDE_DIR})
else()
include_directories(${libhackrf_SOURCE_DIR}/src)
endif()

add_subdirectory(src)

########################################################################
# Create uninstall target
########################################################################

if(NOT HackRF_SOURCE_DIR)
configure_file(
    ${PROJECT_SOURCE_DIR}/../cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)
endif()

=== lib/lpc17xx/Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library.  If not, see <http://www.gnu.org/licenses/>.
##

LIBNAME		= libopencm3_lpc17xx

PREFIX		?= arm-none-eabi

CC		= $(PREFIX)-gcc
AR		= $(PREFIX)-ar
CFLAGS		= -O0 -g \
		  -Wall -Wextra -Wimplicit-function-declaration \
		  -Wredundant-decls -Wmissing-prototypes -Wstrict-prototypes \
		  -Wundef -Wshadow \
		  -I../../include -fno-common \
		  -mcpu=cortex-m3 -mthumb $(FP_FLAGS) -Wstrict-prototypes \
		  -ffunction-sections -fdata-sections -MD -DLPC17XX
# ARFLAGS	= rcsv
ARFLAGS		= rcs
OBJS		= gpio.o

VPATH += ../cm3

include ../Makefile.include

=== lib/lpc43xx_m0/Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
## Copyright (C) 2012 Michael Ossmann <mike@ossmann.com>
## Copyright (C) 2012/2013 Benjamin Vernoux <titanmkd@gmail.com>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library.  If not, see <http://www.gnu.org/licenses/>.
##

LIBNAME		= libopencm3_lpc43xx_m0

PREFIX		?= arm-none-eabi
#PREFIX		?= arm-elf
CC		= $(PREFIX)-gcc
AR		= $(PREFIX)-ar
CFLAGS		= -O2 -g3 -Wall -Wextra -I../../include -fno-common \
		  -mcpu=cortex-m0 -mthumb -Wstrict-prototypes \
		  -ffunction-sections -fdata-sections -MD
# ARFLAGS	= rcsv
ARFLAGS		= rcs

# LPC43xx common files for M4 / M0
OBJ_LPC43XX = gpio.o scu.o i2c.o ssp.o nvic.o uart.o

#LPC43xx M0 specific file + Generic LPC43xx M4/M0 files
OBJS		= vector.o $(OBJ_LPC43XX)

# VPATH += ../usb

# Be silent per default, but 'make V=1' will show all compiler calls.
ifneq ($(V),1)
Q := @
endif

all: $(LIBNAME).a

$(LIBNAME).a: $(OBJS)
	@printf "  AR      $(subst $(shell pwd)/,,$(@))\n"
	$(Q)$(AR) $(ARFLAGS) $@ $^

%.o: %.c
	@printf "  CC      $(subst $(shell pwd)/,,$(@))\n"
	$(Q)$(CC) $(CFLAGS) -o $@ -c $<

%.o: ../lpc43xx/%.c
	@printf "  CC      $(subst $(shell pwd)/,,$(@))\n"
	$(Q)$(CC) $(CFLAGS) -o $@ -c $<
	
clean:
	@printf "  CLEAN   lib/lpc43xx_m0\n"
	$(Q)rm -f *.o *.d
	$(Q)rm -f $(LIBNAME).a

.PHONY: clean

-include $(OBJS:.o=.d)

=== host/hackrf-tools/src/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013 Benjamin Vernoux
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

# Based heavily upon the libftdi cmake setup.

set(INSTALL_DEFAULT_BINDIR "bin" CACHE STRING "Appended to CMAKE_INSTALL_PREFIX")

find_package(FFTW REQUIRED)
include_directories(${FFTW_INCLUDES})
get_filename_component(FFTW_LIBRARY_DIRS ${FFTW_LIBRARIES} DIRECTORY)
link_directories(${FFTW_LIBRARY_DIRS})

SET(TOOLS
	hackrf_transfer
	hackrf_spiflash
	hackrf_cpldjtag
	hackrf_info
	hackrf_debug
	hackrf_clock
	hackrf_sweep
	hackrf_operacake
	hackrf_biast
)

if(MSVC)
	add_library(libgetopt_static STATIC
	    ../getopt/getopt.c
	)
	LIST(APPEND TOOLS_LINK_LIBS ${FFTW_LIBRARIES})
else()
    LIST(APPEND TOOLS_LINK_LIBS m fftw3f)
endif()

if(NOT libhackrf_SOURCE_DIR)
	include_directories(${LIBHACKRF_INCLUDE_DIR})
	LIST(APPEND TOOLS_LINK_LIBS ${LIBHACKRF_LIBRARIES})
else()
	LIST(APPEND TOOLS_LINK_LIBS hackrf)
endif()

if(MSVC)
	LIST(APPEND TOOLS_LINK_LIBS libgetopt_static)
endif()

foreach(tool ${TOOLS})
	add_executable(${tool} ${tool}.c)
	target_link_libraries(${tool} ${TOOLS_LINK_LIBS})
	install(TARGETS ${tool} RUNTIME DESTINATION ${INSTALL_DEFAULT_BINDIR})
endforeach(tool)

=== lib/efm32/efm32g/Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
## Copyright (C) 2012 chrysn <chrysn@fsfe.org>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library. If not, see <http://www.gnu.org/licenses/>.
##

LIBNAME		= libopencm3_efm32g
FAMILY		= EFM32G

PREFIX		?= arm-none-eabi
#PREFIX		?= arm-elf
CC		= $(PREFIX)-gcc
AR		= $(PREFIX)-ar
CFLAGS		= -Os -g \
		  -Wall -Wextra -Wimplicit-function-declaration \
		  -Wredundant-decls -Wmissing-prototypes -Wstrict-prototypes \
		  -Wundef -Wshadow \
		  -I../../../include -fno-common \
		  -mcpu=cortex-m3 $(FP_FLAGS) -mthumb -Wstrict-prototypes \
		  -ffunction-sections -fdata-sections -MD -D$(FAMILY)
# ARFLAGS	= rcsv
ARFLAGS		= rcs
OBJS		=

VPATH += ../:../../cm3

include ../../Makefile.include

=== lib/efm32/efm32gg/Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
## Copyright (C) 2012 chrysn <chrysn@fsfe.org>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library. If not, see <http://www.gnu.org/licenses/>.
##

LIBNAME		= libopencm3_efm32gg
FAMILY		= EFM32GG

PREFIX		?= arm-none-eabi
#PREFIX		?= arm-elf
CC		= $(PREFIX)-gcc
AR		= $(PREFIX)-ar
CFLAGS		= -Os -g \
		  -Wall -Wextra -Wimplicit-function-declaration \
		  -Wredundant-decls -Wmissing-prototypes -Wstrict-prototypes \
		  -Wundef -Wshadow \
		  -I../../../include -fno-common \
		  -mcpu=cortex-m3 $(FP_FLAGS) -mthumb -Wstrict-prototypes \
		  -ffunction-sections -fdata-sections -MD -D$(FAMILY)
# ARFLAGS	= rcsv
ARFLAGS		= rcs
OBJS		=

VPATH += ../:../../cm3

include ../../Makefile.include

=== lib/efm32/efm32lg/Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
## Copyright (C) 2012 chrysn <chrysn@fsfe.org>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library. If not, see <http://www.gnu.org/licenses/>.
##

LIBNAME		= libopencm3_efm32lg
FAMILY		= EFM32LG

PREFIX		?= arm-none-eabi
#PREFIX		?= arm-elf
CC		= $(PREFIX)-gcc
AR		= $(PREFIX)-ar
CFLAGS		= -Os -g \
		  -Wall -Wextra -Wimplicit-function-declaration \
		  -Wredundant-decls -Wmissing-prototypes -Wstrict-prototypes \
		  -Wundef -Wshadow \
		  -I../../../include -fno-common \
		  -mcpu=cortex-m3 $(FP_FLAGS) -mthumb -Wstrict-prototypes \
		  -ffunction-sections -fdata-sections -MD -D$(FAMILY)
# ARFLAGS	= rcsv
ARFLAGS		= rcs
OBJS		=

VPATH += ../:../../cm3

include ../../Makefile.include

=== lib/lpc43xx/m4/Makefile ===
##
## This file is part of the libopencm3 project.
##
## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
## Copyright (C) 2012 Michael Ossmann <mike@ossmann.com>
## Copyright (C) 2012 Benjamin Vernoux <titanmkd@gmail.com>
## Copyright (C) 2013 Alexandru Gagniuc <mr.nuke.me@gmail.com>
##
## This library is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
##
## You should have received a copy of the GNU Lesser General Public License
## along with this library.  If not, see <http://www.gnu.org/licenses/>.
##

LIBNAME		= libopencm3_lpc43xx

FP_FLAGS	?= -mfloat-abi=hard -mfpu=fpv4-sp-d16
PREFIX		?= arm-none-eabi

CC		= $(PREFIX)-gcc
AR		= $(PREFIX)-ar
CFLAGS		= -O2 -g3 \
		  -Wall -Wextra -Wimplicit-function-declaration \
		  -Wredundant-decls -Wmissing-prototypes -Wstrict-prototypes \
		  -Wundef -Wshadow \
		  -I../../../include -fno-common \
		  -mcpu=cortex-m4 -mthumb -Wstrict-prototypes \
		  -ffunction-sections -fdata-sections -MD \
		  $(FP_FLAGS) -DLPC43XX -DLPC43XX_M4

ARFLAGS		= rcs

# LPC43xx common files for M4 / M0
OBJ_LPC43XX     = gpio.o scu.o i2c.o ssp.o uart.o timer.o wwdt.o

#LPC43xx M4 specific file + Generic LPC43xx M4/M0 files
OBJS		= $(OBJ_LPC43XX) ipc.o

VPATH += ../:../../cm3

include ../../Makefile.include

=== debian/changelog ===
hackrf (2024.02.1-4) unstable; urgency=medium

  * update to v2024.02.1-115-gd56d6527 for CMake updates (Closes: #1112983)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 15 Oct 2025 22:26:36 -0400

hackrf (2024.02.1-3) unstable; urgency=medium

  * Relicense com.greatscottgadgets.hackrf.metainfo.xml (Closes: #1078193)
  * Update Standards-Versio (no changes)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 20 Jan 2025 22:19:39 -0500

hackrf (2024.02.1-2) unstable; urgency=medium

  * Source-only upload for transitions.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 06 Apr 2024 19:57:25 -0400

hackrf (2024.02.1-1) unstable; urgency=medium

  * New upstream release.
    - requires update of firmware on the HackRF.
  * re-enable hackrf-firmware package generation
  * Major changes in this release include:
    - A new utility, hackrf_biast, provides a way to control the "bias
    tee" antenna port power output on HackRF One. Thank you, Jonathan
    Suite (AI6AJ)!
    - Completely new and comprehensive libhackrf API documentation
    generated from source is now available in the release package. Thank
    you, László Baráth!
    - hackrf_sweep now supports more FFTW features including the ability
    to use a wisdom file. Thank you, Jonathan Suite (AI6AJ)!
    - HackRF One r10, the latest hardware revision, is based on r8,
    reverting most of the changes made in r9.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 09 Mar 2024 11:40:31 -0500

=== debian/control ===
Source: hackrf
Section: libs
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       gcc-arm-none-eabi,
               libfftw3-dev,
	       libnewlib-arm-none-eabi,
               libusb-1.0-0-dev,
               pkgconf
Build-Depends-Indep: dfu-util,
                     latexmk,
                     python3-sphinx,
                     python3-sphinx-rtd-theme,
                     python3-yaml,
                     tex-gyre,
                     texlive-latex-extra
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://greatscottgadgets.com/hackrf/
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-hackrf
Vcs-Git: https://salsa.debian.org/bottoms/pkg-hackrf.git

Package: hackrf-doc
Section: doc
Architecture: all
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         sphinx,
         ${misc:Depends}
Description: Software defined radio peripheral - documentation
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains generated documentation.

Package: libhackrf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libhackrf0 (= ${binary:Version}), ${misc:Depends}
Description: Software defined radio peripheral - development
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains development files.

Package: libhackrf0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Software defined radio peripheral - runtime library
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains the shared library.

Package: hackrf
Section: comm
Architecture: any
Depends: libhackrf0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Software defined radio peripheral - utilities
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains a set of command line utilities:
  * hackrf_clock: HackRF clock configuration utility
  * hackrf_cpldjtag: program CLPD
  * hackrf_debug: chip register read/write/config tool
  * hackrf_info: probe device and show configuration
  * hackrf_operacake: control of operacake board via hackrf
  * hackrf_spiflash: read and write flash data from file.
  * hackrf_sweep: control frequency sweep of hackrf
  * hackrf_transfer: file based transmit and receive sdr

Package: hackrf-firmware
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hackrf
Suggests: dfu-util
Description: Firmware for HackRF devices
 The HackRF hardware needs some firmware to run. The firmware is built with
 arm-none-eabi-gcc. This package contains a number of firmware images that
 may be programmed into the HackRF hardware using the 'hackrf_spiflash -w'
 command or dfu-util.
 .
 The following hardware is supported:
  * hackrf_jawbreaker
  * hackrf_one
  * hackrf_rad1o
 .
 The firmware images are installed in /usr/share/hackrf/firmware/

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH

%:
	dh $@ --sourcedirectory=host --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=host --builddirectory=build -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)
	- cp -p build/libhackrf/53-hackrf.rules debian/libhackrf0.udev

override_dh_auto_build-indep: build-arch
	cd docs && make html
	cd docs && make latex
	cd docs && make latexpdf
	cd docs/build/html/_static && rm jquery.js
	cd docs/build/html/_static && ln -s /usr/share/javascript/jquery/jquery.js jquery.js
	cd docs/build/html/_static && rm _sphinx_javascript_frameworks_compat.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/_sphinx_javascript_frameworks_compat.js _sphinx_javascript_frameworks_compat.js
	cd docs/build/html/_static && rm doctools.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/doctools.js doctools.js
	cd docs/build/html/_static && rm language_data.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/language_data.js_t language_data.js
	cd docs/build/html/_static && rm searchtools.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/searchtools.js searchtools.js
	cd docs/build/html/_static && rm sphinx_highlight.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/sphinx_highlight.js sphinx_highlight.js
	rm -rf docs/build/html/_static/fonts
	cp -p -r firmware-libopencm3/* firmware/libopencm3/
	cd firmware && CFLAGS=-Wall CXXFLAGS=-Wall cmake -DCMAKE_TRY_COMPILE_TARGET_TYPE="STATIC_LIBRARY" -DCMAKE_VERBOSE_MAKEFILE=ON -DBOARD=HACKRF_ONE -B build_hackrf
	cd firmware && cmake --build build_hackrf
	cd firmware && CFLAGS=-Wall CXXFLAGS=-Wall cmake -DCMAKE_TRY_COMPILE_TARGET_TYPE="STATIC_LIBRARY" -DCMAKE_VERBOSE_MAKEFILE=ON -DBOARD=JAWBREAKER -B build_jawbreaker
	cd firmware && cmake --build build_jawbreaker
	cd firmware && CFLAGS=-Wall CXXFLAGS=-Wall cmake -DCMAKE_TRY_COMPILE_TARGET_TYPE="STATIC_LIBRARY" -DCMAKE_VERBOSE_MAKEFILE=ON -DBOARD=RAD1O -B build_rad1o
	cd firmware && cmake --build build_rad1o
	cp -p firmware/build_jawbreaker/hackrf_usb/hackrf_usb.bin firmware/hackrf_jawbreaker_usb.bin
	cp -p firmware/build_hackrf/hackrf_usb/hackrf_usb.bin firmware/hackrf_one_usb.bin
	cp -p firmware/build_rad1o/hackrf_usb/hackrf_usb.bin firmware/hackrf_rad1o_usb.bin
	chmod -x firmware/hackrf_jawbreaker_usb.bin
	chmod -x firmware/hackrf_one_usb.bin
	chmod -x firmware/hackrf_rad1o_usb.bin
	cp -p firmware/build_jawbreaker/hackrf_usb/hackrf_usb.dfu firmware/hackrf_jawbreaker_usb.dfu
	cp -p firmware/build_hackrf/hackrf_usb/hackrf_usb.dfu firmware/hackrf_one_usb.dfu
	cp -p firmware/build_rad1o/hackrf_usb/hackrf_usb.dfu firmware/hackrf_rad1o_usb.dfu

override_dh_installdocs-indep:
	dh_installdocs --indep

override_dh_installudev:
	dh_installudev
	# This should be harmless for indep builds or after dh_installudev changes the install path.
	set -e; if test -d debian/libhackrf0/lib/udev/rules.d; then mv debian/libhackrf0/lib/udev debian/libhackrf0/usr/lib; fi
	set -e; if test -d debian/libhackrf0/lib; then rmdir debian/libhackrf0/lib; fi

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/greatscottgadgets//hackrf/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
opts="component=firmware-libopencm3, mode=git, pgpmode=none" \
 https://github.com/mossmann/libopencm3.git HEAD ignore
